#ifndef __ipl_h
#define __ipl_h

#define DATAFLASH_PAGE_SIZE 264

extern unsigned char sram_data[64];

void exi_sram_read(void *data);
void exi_sram_write(void *data);

void exi_ipl_write(unsigned long addr, unsigned long val);
unsigned char rom_read(int addr);
void rom_readn(int addr, unsigned char *d, int len);
void rom_write(int addr, unsigned char c);
void s_putc(unsigned char c);

void ipl_read(void *dst, unsigned long addr, int len);
void ipl_set_config(unsigned char c);
void ipl_boot(int what);

/* ipl functions for rob's modchip  */
int ipl_rob_test();
void ipl_rob_read(void *dst, unsigned long addr, int len);

#endif
