#ifndef _GDBSTUB_H_
#define _GDBSTUB_H_

/* Port number to use for gdb stub */
#define GDBSTUB_PORT 2828

void gdbstub_init();
void gdbstub_breakpoint();
//void gdbstub_printf(char *string, ...);
void gdbstub_puts(char *buf);

void gdbstub_enter_critical();
void gdbstub_leave_critical();

//#define ASSERT(x) { gdbstub_printf(##x); gdbstub_breakpoint(); }

// exception handlers
void gdbstub_handle_reset(int irq, void *ctx);
void gdbstub_handle_breakpoint();

#endif
