#ifndef __dvd_h
#define __dvd_h

unsigned int dvd_read(void *dst, int len, unsigned int offset);
unsigned int dvd_read_id(void *dst);
void dvd_reset();
unsigned int dvd_init();
void dvd_motor_off();
void dvd_fix_streaming();
void dvd_set_audio(int enable, int len);
void dvd_set_streaming();
unsigned int dvd_get_error(void);
unsigned int dvd_get_diconfig(void);

int dvd_seek(int offset);


const char *dvd_get_error_message(void);
          
unsigned int npdp_getid(unsigned char *dst);

#endif
