#ifndef VIDEO_H
#define VIDEO_H

#include "types.h"

#define VIDEO_640X480_NTSC_YUV16     (0)
#define VIDEO_640X480_PAL50_YUV16    (1)
#define VIDEO_640X480_PAL60_YUV16    (2)

#define VIDEO_FRAMEBUFFER_1          (1)
#define VIDEO_FRAMEBUFFER_2          (2)
#define VIDEO_FRAMEBUFFER_BOTH       (0)


void video_init(u32 VideoMode);
void video_set_framebuffer(u32 Which, u32 FrameBufferAddr);
void video_wait_vsync(void);
int video_get_mode(void);
#endif
